 
  //Fonction setup(), appelée au démarrage de la carte Arduino 
void setup()
{
  #include <math.h>   // appel de la bibliotheque Maths pour la fonction logarithme neperien notee log dans la suite
  Serial.begin(9600); // initialisation de la communication série à 9600 bps
  Serial.println("CLEARDATA");  // efface les données déjà présentes
  Serial.println("LABEL;Temps (ms);tension U (V);tension Uther (V);Resistance Rth (ohms);temperature (C)"); // prepare les titres des colonnes, transferees ensuite dans Excel
  
}

  // Fonction loop(), appelée en boucle si la carte Arduino est alimentée
void loop()
{
  unsigned long temps=millis();
  unsigned long tempslimite = 3000UL;// fixe la duree limite a 3 s soit 3 000 ms
  while(temps<tempslimite)
{
    // les instructions entre ces accolades sont répétées
    // tant que la condition est vraie

 
    // Declaration et initialisation des variables
  double Rther = 1.0 ;
  double R = 10000.0 ; // valeur de la resistance du pont diviseur de tension
  double U = 0.0 ;
  double Uther = 0.0 ;
  double beta = 0.0 ;
  double Rzero = 0.0 ;
  double Tzero = 0.0 ;
  double diff = 0.0 ;
  double quotient = 0.0 ;
  double temperature = 0.0 ;
  double tensionU = 0.0;
  double tensionUther = 0.0;
  


   // lecture des tensions U et Uther sur A0 et A1 et initialisation du compteur temporel
  temps = millis();
  U = analogRead(0) ;
  tensionU = map(U, 0, 1023, 0, 5000); // conversion de la tension lue sur A0 en valeur decimal
  tensionU = tensionU/1000; // conversion de la tension lue sur A0 de mV en V
  
  Uther = analogRead(1) ;
  tensionUther = map(Uther, 0, 1023, 0, 5000); // conversion de la tension lue sur A1 en valeur decimal
  tensionUther = tensionUther/1000; // conversion de la tension lue sur A1 de mV en V


   // Declarations des variables beta  Rzero Tzero issues de la modelisation temperature resistance Rth
  beta = 3431 ;
  Rzero = 100055 ;
  Tzero = 299.8 ;

   // Calcul de la valeur de Rth a partir des tensions mesurees sur le pont diviseur de tension
  diff = tensionU - tensionUther ;
  quotient = ( 1 / diff ) ;
  Rther =tensionUther* ( quotient * R ) ;

    // Calcul de la temperature a partir de la modelisation de la courbe temp Rth
   temperature = (1/(log(Rther/R)/beta+1/Tzero)-273.15) ;


  // Envoi la mesure au PC pour affichage
  
  Serial.print("DATA,TIME,");  // envoi du temps et la mesure à Excel via la macro Plx daq sous Excel
 
  Serial.print(tensionU);
  Serial.print(",");
  Serial.print(tensionUther);
  Serial.print(",");
  Serial.print(Rther);
  Serial.print(",");
  Serial.println(temperature);  
  
  delay(1000); // intervalle de temps entre deux executions de la boucle donc entre deux mesures en millisecondes
  
}

}


